

/*
 * fino.frag -- find block (optional) and character device file inode numbers
 *
 * The caller must define:
 *
 *	HASBLKDEV	to activate the block device inode lookup
 *
 * $Id: fino.frag,v 1.1 96/07/25 10:59:06 abe Exp $
 */


#if	defined(HASBLKDEV)


/*
 * find_bl_ino() - find the inode number for a block device file
 */

void
find_bl_ino()
{
	dev_t ldev, tdev;
	int low, hi, mid;

	readdev();
	low = mid = 0;
	hi = BNdev - 1;
	ldev = Lf->dev;
	while (low <= hi) {
		mid = (low + hi) / 2;
		tdev = BSdev[mid]->rdev;
		if (ldev < tdev)
			hi = mid - 1;
		else if (ldev > tdev)
			low = mid + 1;
		else {
			Lf->inode = (unsigned long)BSdev[mid]->inode;
			if (Lf->inp_ty == 0)
				Lf->inp_ty = 1;
			return;
		}
	}
}
#endif	/* defined(HASBLKDEV) */


/*
 * find_ch_ino() - find the inode number for a character device file
 */

void
find_ch_ino()
{
	dev_t ldev, tdev;
	int low, hi, mid;

	readdev();
	low = mid = 0;
	hi = Ndev - 1;
	ldev = Lf->dev;
	while (low <= hi) {
		mid = (low + hi) / 2;
		tdev = Sdev[mid]->rdev;
		if (ldev < tdev)
			hi = mid - 1;
		else if (ldev > tdev)
			low = mid + 1;
		else {
			Lf->inode = (unsigned long)Sdev[mid]->inode;
			if (Lf->inp_ty == 0)
				Lf->inp_ty = 1;
			return;
		}
	}
}
